//This is a sample C++ program for Borland C++ (Version 5.0 and later),
//which is to be linked to PSIM via DLL.

//To compile it into DLL:

//   From Borland C++ environment:
//      - From the "File" menu, choose "New"/"Project". Set the project
//        name as "bc_user4.ide", the Target Type as "Dynamic Library [.dll]",
//        the Platform as "Win32", and select "Static" link.
//      - Copy this sample file into the directory where the project resides.
//      - From the "Project" window, delete the files "bc_user4.def" and
//        "bc_user4.rc".
//      - Make sure that, in the "Option" menu, under "Project"/"32-bit Compilers"/
//        "Calling Convention", calling convention "C" is selected.
//      - From the "Build" menu, choose "Build All".

//After the DLL file "bc_user4.dll" is generated, backup the default DLL file
//into another file or directory, and copy your DLL file into the PSIM
//directory (and overwriting the existing file). You are then ready to run
//PSIM with your DLL.


//This sample program multiplies the input array in[0:2] by 5, and stores
//the output in out[0:2].

//Do not change the following line.
extern "C"
{

//You may change the variable names (say from "t" to "Time").
//But DO NOT change the function name, number of variables,
//variable type, and sequence.

// Variables:
//      t: Time, passed from PSIM by value
//   delt: Time step, passed from PSIM by value
//     in: input array, passed from PSIM by reference
//    out: output array, sent back to PSIM (Note: the values of out[*] can
//         be modified in PSIM)

// The maximum length of the input and output array "in" and "out" is 20.

void __declspec(dllexport) bc_user4 (double t, double delt, double *in, double *out)

{
//Place your code here............begin

	int i;

	for (i=0; i<3; i++)
	{
		out[i] = in[i]*5.;
	}

//Place your code here............end
}

}
